﻿Public Class ChartTrendline

    'Create static variables used to plot Custom 
    'Trendlines to track the current on the TrackBars
    Shared bar1 As Boolean = False
    Shared a As Integer = 0, b As Integer = 0
    Public Shared Function y1() As Integer
        If bar1 = True Then
            Return b
        Else
            Return a
        End If
    End Function

    Public Shared Function y2() As Integer
        If bar1 = True Then
            Return a
        Else
            Return b
        End If
    End Function

    Private Sub DrawLevelLine()
        c1Chart1.ChartGroups(0).ChartData.TrendsList.Clear()
        ' create trend line
        Dim tl As C1.Win.C1Chart.TrendLine = c1Chart1.ChartGroups(0).ChartData.TrendsList.AddNewTrendLine()
        ' setup line properties
        tl.LineStyle.Color = Color.DarkRed
        tl.LineStyle.Thickness = 3
        tl.LineStyle.Pattern = C1.Win.C1Chart.LinePatternEnum.Dash
        ' set custom trend line
        tl.CustomTrendLine = New CustomTrendLine_()
        If bar1 = True Then
            bar1 = False
        End If
    End Sub

    Private draw As Boolean = False
    'Capture the Trackbar Values
    Private Sub TrackBar1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles TrackBar1.ValueChanged
        bar1 = True
        draw = True
        a = TrackBar1.Value
        b = TrackBar2.Value
    End Sub

    Private Sub TrackBar2_ValueChanged(sender As System.Object, e As System.EventArgs) Handles TrackBar2.ValueChanged
        bar1 = False
        draw = True
        a = TrackBar1.Value
        b = TrackBar2.Value
    End Sub

    Private Sub TrackBar1_MouseUp(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles TrackBar1.MouseUp
        If draw Then
            DrawLevelLine()
            draw = False
        End If
    End Sub

    Private Sub TrackBar2_MouseUp(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles TrackBar2.MouseUp
        If draw Then
            DrawLevelLine()
            draw = False
        End If
    End Sub

    Private Sub ChartTrendline_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        C1Chart1.BackColor = Color.LemonChiffon
    End Sub
End Class

Public Class CustomTrendLine_
    Implements C1.Win.C1Chart.ICustomTrendLine
    Private _x() As Double
    Private _y() As Double

    Public Sub Calculate(ByVal tl As C1.Win.C1Chart.TrendLine, ByVal x() As Double, _
   ByVal y() As Double) Implements C1.Win.C1Chart.ICustomTrendLine.Calculate
        If x Is Nothing Or x.Length = 0 Or y Is Nothing Or y.Length = 0 Then
            _x = Nothing
            _y = Nothing
            Return
        End If

        ' find min and max
        Dim xmin As Double = x(0), xmax = x(0)
        Dim ymin1 As Double = y(0), ymax1 = y(0)

        Dim ff As ChartTrendline = New ChartTrendline()
        xmin = ff.C1Chart1.ChartArea.AxisX.Min
        xmax = ff.C1Chart1.ChartArea.AxisX.Max

        ymin1 = ChartTrendline.y1()
        ymax1 = ChartTrendline.y2()

        _x = New Double(1) {}
        _y = New Double(1) {}

        _x(0) = xmin
        _y(0) = ymin1
        _x(1) = xmax
        _y(1) = ymax1
    End Sub



    Public Function GetXValues() As Double() _
     Implements C1.Win.C1Chart.ICustomTrendLine.GetXValues
        Return _x
    End Function

    Public Function GetYValues() As Double() _
     Implements C1.Win.C1Chart.ICustomTrendLine.GetYValues
        Return _y
    End Function

    ' don't use it just return something
    Public Function GetY(ByVal x As Double) As Double _
     Implements C1.Win.C1Chart.ICustomTrendLine.GetY
        Return 0
    End Function

    Public ReadOnly Property Text() As String _
     Implements C1.Win.C1Chart.ICustomTrendLine.Text
        Get
            Return "Custom trend"
        End Get
    End Property

End Class